<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 73 Pizza365 CRUD</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">DevCamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">LinhLT</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="voucher.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="menu.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menu CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="drink.crud.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="country.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Country CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="region.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Region CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="user.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>User CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="order.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="prize-history.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Prize History CRUD</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Pizza 365</h1>
          </div>
          
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Quản trị đồ uống</h2>
        <div class="row">
        <!--<div class="col-sm-12">
          <button id="btn-clear-data" class="btn btn-danger">Delete All Data</button>
        </div>-->
        </div>
        <div class="jumbotron container">
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="drink-code">Mã Nước uống</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-drink-code" name="drink-code" placeholder="drink code"
            class="form-control">
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="drink-name">Tên Nước uống</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-drink-name" name="drink-name" placeholder="drink name"
            class="form-control">
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="price">Đơn giá</label>
          </div>
          <div class="col-sm-9">
            <input type="number" id="input-price" name="price" placeholder="price" class="form-control">
          </div>
          </div>
          <!--
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="note">Ghi chú</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
          </div>
          </div>
          -->
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="createDate">Ngày Tạo</label>
          </div>
          <div class="col-sm-9">
            <input type="date" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="updateDate">Ngày sửa</label>
          </div>
          <div class="col-sm-9">
            <input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
          </div>
          </div>
          <div class="row pull-right">
            <div class="col-sm-3">
            </div>
            <div class="col-sm-9">
              <div class ="row">
                <div class="col-sm-3">
                  <button id="btn-update-drink" class="btn btn-info w-100"><i class="fas fa-edit"></i>&nbsp;Update</button>
                </div>
                <div class="col-sm-3">
                  <button id="btn-delete-drink" class="btn btn-danger w-100"><i class="fas fa-trash"></i>&nbsp;Delete</button>
                </div>
                <div class="col-sm-3">
                  <button id="btn-create-drink" class="btn btn-success w-100"><i class="fa fa-plus"></i>&nbsp;Add New</button>
                </div>
                <div class = "col-sm-3">
                  <button id="btn-cancel" class="btn btn-secondary w-100">Cancel</button>
                </div>
              </div>
            </div>
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="user-table">
          <thead>
            <tr>
              <th>STT</th>
              <th>Mã nước uống</th>
              <th>Tên nước uống</th>
              <th>Đơn giá</th>
              <!--<th>Ghi Chú</th>-->
              <th>Ngày tạo</th>
              <th>Ngày cập nhật</th>
            </tr>
        </table>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0.0
    </div>
    <strong>Copyright &copy; 2023 <a href="">DevCamp 120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<script>
  "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
// Biến toàn cục để lưu trữ id drink đang đc update or delete. Mặc định = 0;
var gDrinkId = 0;
const gBASE_URL = "http://localhost:8080/drinks";
const gCONTENT_TYPE = "application/json;charset=UTF-8";

$(document).ready(function(){
	var table = $("#user-table").DataTable({
		"columns": [
			{"data":"id"},
			{"data":"maNuocUong"},
			{"data":"tenNuocUong"},
			{"data":"price"},
			//{"data":"ghiChu"},
			{"data":"ngayTao"},
			{"data":"ngayCapNhat"},
		]
	})
	loadDataToTable();
		
	/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
	//Subtask 1- add click event to all rows
	$("#user-table").on("click", "tr", function(){
		onRowClick(this);
	})
	//task 2 - Update drink: add event to save data button
	$("#btn-update-drink").on("click",function(){
		onUpdateButtonClick();
	});
	//task 3 - Create new drink
	$("#btn-create-drink").on("click",function(){
		onCreateButtonClick();
	});
	//task 4 - Delete drink selected
	$("#btn-delete-drink").on("click",function(){
		onDeleteButtonClick();
	});
	//task 5 - Cancel
	$("#btn-cancel").on("click",function(){
		onCancelBtnClick();
	});
	/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
	//hàm xử lý sự kiện click row
	function onRowClick(paramRow){
		gDrinkId = $(paramRow).find("td:eq(0)").html();
		console.log("Drink id of selected row: " + gDrinkId);
		//lấy thông tin drink của row được click và hiển thị lên form
		var vDrink = callApiGetDrinkById(gDrinkId);
	};
	
	//hàm xử lý sự kiện nút save data
	function onUpdateButtonClick(){
		//khai báo drink obj
		var vDrinkObj = {
			maNuocUong: "",
			tenNuocUong: "",
			price: -1,
		//	ghiChu:"",
		}
		// B1: Thu thập dữ liệu
		getUpdateDrinkData(vDrinkObj);
		// B2: Validate update
		var vIsDrinkValidate = validateDrinkData(vDrinkObj);
    	if (vIsDrinkValidate){
			// B3: update drink
			$.ajax({
				url: gBASE_URL +"/"+ gDrinkId,
				type: "PUT",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vDrinkObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleUpdateDrinkSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	
	//hàm xử lý sự kiện nút thêm drink
	function onCreateButtonClick(){
		//khai báo drink obj
		var vDrinkObj = {
			maNuocUong: "",
			tenNuocUong: "",
			price: -1,
		//	ghiChu:"",
		}
		// B1: Thu thập dữ liệu
		getUpdateDrinkData(vDrinkObj);
		// B2: Validate data
		var vIsDrinkValidate = validateDrinkData(vDrinkObj);
    	if (vIsDrinkValidate){
			// B3: create drink
			$.ajax({
				url: gBASE_URL ,
				type: "POST",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vDrinkObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleCreateDrinkSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	//hàm xử lý sự kiện nút xóa drink được chọn và hiển thị trên form
	function onDeleteButtonClick(){
    //b1: thu thập dữ liệu
    //b2: validate
    //b3: thực hiện xóa - gọi API
      $.ajax({
        url: gBASE_URL +"/"+ gDrinkId,
        type: "DELETE",
        success: function(paramRes) {
          handleDeleteDrinkSuccess();
        },
        error: function(paramErr) {
          alert("Xóa drink không thành công");
        }
      });
	}
  //xóa data trên form
  function onCancelBtnClick(){
    $("#input-drink-code").val("");
		$("#input-drink-name").val("");
    $("#input-price").val("");
		$("#input-createDate").val("");
    $("#input-updateDate").val("");   
	}

	/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
	//load data to table
  function loadDataToTable(){
    $.ajax({
      url: gBASE_URL,
      type: "GET",
      dataType: "json",
      success: function(res){
        console.log(res);
        table.clear();
        table.rows.add(res);
        table.draw();
      },
      error: function(err){
        console.log(err.response);
      }
    })
  }
  
  //hàm gọi API lấy thông tin drink của dòng được chọn
	function callApiGetDrinkById(paramId){
		$.ajax({
			url: gBASE_URL +"/"+ paramId,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				displayDrinkData(res);
			},
			error: function(err){
				console.log(err.responseText);
			}
		})
	}
	//hàm hiển thị thông tin drink của dòng được click
	function displayDrinkData(paramDrink){
		$("#input-drink-code").val(paramDrink.maNuocUong);
		$("#input-drink-name").val(paramDrink.tenNuocUong);
		$("#input-price").val(paramDrink.price); 
		//$("#input-note").val(paramDrink.ghiChu); 
		$("#input-createDate").val(paramDrink.ngayTao); 
		$("#input-updateDate").val(paramDrink.ngayCapNhat);  
	}
	// hàm thu thập dữ liệu để update drink
	function getUpdateDrinkData(paramDrinkObj) {
		paramDrinkObj.maNuocUong =$("#input-drink-code").val().trim();
		paramDrinkObj.tenNuocUong =$("#input-drink-name").val().trim();
		paramDrinkObj.price = parseInt($("#input-price").val()); 
		//paramDrinkObj.ghiChu = $("#input-note").val().trim(); 
	}

	// hàm validate data
	function validateDrinkData(paramDrinkObj) {
		if (paramDrinkObj.maNuocUong === "") {
		alert("Cần nhập mã nước uống");
		return false;
		}
		if (paramDrinkObj.tenNuocUong === "") {
		alert("Cần nhập tên nước uống");
		return false;
		}
		if (isNaN(paramDrinkObj.price)) {
		alert("Đơn giá cần nhập vào phải là số");
		return false;
		}

		return true;
	}
	
	//hiển thị cập nhật drink thành công
	function handleUpdateDrinkSuccess(){
		alert("Sửa drink có id: " + gDrinkId + " thành công!");
    loadDataToTable();
	};
	//hiển thị thêm drink thành công
	function handleCreateDrinkSuccess(){
		alert("Thêm drink thành công!");
    loadDataToTable();
	};
	//hiển thị cập nhật drink thành công
	function handleDeleteDrinkSuccess(){
		alert("Xóa drink có id: " + gDrinkId + " thành công!");
    loadDataToTable();
	};
})
</script>
</body>
</html>
